(function($){
$.widget('ui.apex_modal_page', {
   options: {
      loadingImageSrc: null,
      initialHeight: null,
      initialWidth: null,
      effectsSpeed: null
   },
   _createPrivateStorage: function() {
      var uiw=this;
      
      uiw._values = {
         url: null, 
         dialogTitle: null, 
         closeSelector: null, 
         preventDefault: null, 
         heightWidthMode: null,
         height: null,
         width: null,
         closeElementSelector: null,
         modalPageId: null,
         modalPageCloseValue: null,
         dialogTop: 0,
         dialogLeft: 0,
         iframeHeight: 0,
         iframeWidth: 0,
         hasVScroll: false,
         hasHScroll: false,
         autoClosed: false
      };
      
      uiw._elements = {
         $window: {},
         $outerDialog: {},
         $dialog: {},
         $wrapper: {},
         $iframe: {}
      };
   },
   _create: function() {
      var uiw = this;
      var loadImg = new Image();
      loadImg.src = uiw.options.loadingImageSrc;

      uiw._createPrivateStorage();
   },
   _initElements: function() {
      uiw = this;
      
      uiw._elements.$window = $(window);
      uiw._elements.$outerDialog; //Transient, set after dialog initalizes
      uiw._elements.$dialog = $('div.modal-page-container');
      uiw._elements.$wrapper = $('div.modal-page-iframe-wrapper');
      uiw._elements.$iframe = $('iframe#modal-page-iframe');
   },
   openPage: function(dialogTitle, closeSelector, modalPageId, heightWidthMode, height, width) {
      var uiw = this;
      var dialogHtml =
            '<div class="modal-page-container ui-widget">\n'
         +  '   <div class="modal-page-iframe-wrapper">\n'
         +  '      <img id="modal-page-loading-img" src="' + uiw.options.loadingImageSrc + '">\n'
         +  '      <iframe id="modal-page-iframe" name="modal-page-iframe" class="ui-helper-hidden-accessible" frameborder="0"></iframe>'
         +  '   </div>\n'
         +  '</div>\n';
      
      uiw._values.autoClosed = false;
      uiw._values.dialogTitle = dialogTitle; 
      uiw._values.closeElementSelector = closeSelector;
      uiw._values.modalPageId = modalPageId;
      uiw._values.heightWidthMode = heightWidthMode;
      uiw._values.height = height;
      uiw._values.width = width;
      
      $('body').append(
         dialogHtml
      );
      
      uiw._initElements();
      
      uiw._elements.$wrapper.css({
        'height': uiw.options.initialHeight,
        'width': uiw.options.initialWidth
      });
      
      uiw._elements.$dialog.dialog({
         disabled: false,
         autoOpen: false,
         show: null,
         hide: 'drop',
         closeOnEscape: true,
         closeText: "Close",
         dialogClass: "modal-page-dialog",
         draggable: true,
         height: "auto",
         maxHeight: false,
         maxWidth: false,
         minHeight: false,
         minWidth: false,
         modal: true,
         resizable: false,
         stack: true,
         title: dialogTitle,
         width: "auto",
         close: function() {
            $(this).dialog('destroy');
            
            uiw._elements.$dialog.remove();
            
            if (!uiw._values.autoClosed) {
               $(document).trigger('modalpagemanualclose', {
                  "modalPageId": uiw._values.modalPageId,
                  "modalPageCloseValue": ((uiw._values.modalPageCloseValue) ? uiw._values.modalPageCloseValue : "")
               });
            }
            
            uiw._values.modalPageCloseValue = null;
         }
      });
      
      uiw._elements.$outerDialog = $('div.modal-page-dialog');

      uiw._values.dialogTop = uiw._elements.$window.height()*.05;

      uiw._values.dialogLeft =
         (uiw._elements.$window.width()/2) -
            (uiw._elements.$outerDialog.outerWidth(true)/2);
      if (uiw._values.dialogLeft < 0) {
         uiw._values.dialogLeft = 0;
      }

      uiw._elements.$dialog.dialog('option', 'position', [uiw._values.dialogLeft, uiw._values.dialogTop]);

      uiw._elements.$window.bind('resize', {uiw: uiw}, uiw._checkResizeTimer);

      uiw._elements.$dialog.dialog('open');
      
      uiw._elements.$iframe
         .bind('load', {uiw: uiw}, uiw._handleIframeLoad)
         .attr('src', uiw._values.url);
   },
   openPageFromApexThis: function(apexThis) {
      var uiw = this;
      var urlLocation = apexThis.action.attribute02;
      var staticUrl = apexThis.action.attribute03;
      var attrName = apexThis.action.attribute05;  
      
      if (urlLocation === 'STATIC') {
         uiw._values.url = staticUrl;
      } else if (urlLocation === 'TRIG_ELEMENT_ATTR') {
         uiw._values.url = $(apexThis.triggeringElement).attr(attrName);
      }
      
      uiw.openPage(
         apexThis.action.attribute01,
         apexThis.action.attribute06,
         apexThis.action.attribute10,
         apexThis.action.attribute07,
         apexThis.action.attribute08,
         apexThis.action.attribute09
      );  
   },
   _handleIframeLoad: function(eventObj) {
      var uiw = eventObj.data.uiw;
      var $closeElementSelector = uiw._elements.$iframe.contents().find(uiw._values.closeElementSelector);
      var childWindow = uiw._elements.$iframe.get(0).contentWindow;
      var jQIframe = childWindow.apex.jQuery;
      
      jQIframe(uiw._elements.$iframe.contents().get(0)).bind('apexbeforepagesubmit', function() {
         uiw._elements.$iframe.addClass('ui-helper-hidden-accessible');
         $('img#modal-page-loading-img').show();
      });
      
      uiw._elements.$iframe.contents().find('#apex-dev-toolbar,#htmldbDevToolbar').remove();
      
      if ($closeElementSelector.length) {
         uiw._values.autoClosed = true;
      
         uiw._elements.$dialog.dialog('close');
         
         $(document).trigger('modalpageautoclose', {
            "modalPageId": uiw._values.modalPageId,
            "$modalPageCloseObject": $closeElementSelector
         });
      } else {
         uiw._elements.$iframe.contents().find('body').css('margin', '0px');
      
         $('img#modal-page-loading-img').hide();

         uiw._resizeModal();
         
         uiw._elements.$iframe.removeClass('ui-helper-hidden-accessible');
      }
   },
   _resizeModal: function() {
      var uiw = this;
      var iframeHtml = uiw._elements.$iframe.contents().find('html');
      uiw._elements.$window.unbind('resize', uiw._checkResizeTimer);

      uiw._updateModalMeasurements();

      if (uiw.options.effectsSpeed === 0) {
         uiw._elements.$wrapper.css({
            'height': uiw._values.iframeHeight + 'px',
            'width': uiw._values.iframeWidth + 'px'
         });
         
         uiw._elements.$outerDialog.css('left', uiw._values.dialogLeft + 'px');
      }
      else {
         uiw._elements.$wrapper.fadeTo(0, 0);
         uiw._elements.$wrapper.animate(
            {height: uiw._values.iframeHeight + 'px'},
            uiw.options.effectsSpeed,
            function() {
               uiw._elements.$wrapper.animate({
                     width: uiw._values.iframeWidth + 'px'
                  },
                  uiw.options.effectsSpeed,
                  function() {
                     uiw._elements.$wrapper.fadeTo(uiw.options.effectsSpeed, 1);
                  }
               );
               uiw._elements.$outerDialog.animate({
                     left: uiw._values.dialogLeft + 'px'
                  },
                  uiw.options.effectsSpeed
               );
            }
         );
      }
      
      if (uiw._values.hasVScroll) {
         iframeHtml.css('overflow-y', 'auto');
      }
      else {
         iframeHtml.css('overflow-y', 'hidden');
      }
      
      if (uiw._values.hasHScroll) {
         iframeHtml.css('overflow-x', 'auto');
      }
      else {
         iframeHtml.css('overflow-x', 'hidden');
      }
      
      uiw._elements.$window.bind('resize', {uiw: uiw}, uiw._checkResizeTimer);
   },
   _checkResizeTimer: function(eventObj) {
      var uiw = eventObj.data.uiw;
      
      if (uiw._values.timer) {
         clearTimeout(uiw._values.timer);
      }

      uiw._values.timer = setTimeout(function() {uiw._handleWindowResize();}, 50);
   },
   _handleWindowResize: function() {
      var uiw = this;
      var iframeHtml = uiw._elements.$iframe.contents().find('html');
      
      uiw._updateModalMeasurements();
      
      uiw._elements.$wrapper.css({
         'height':uiw._values.iframeHeight + 'px',
         'width':uiw._values.iframeWidth + 'px'
      });
      uiw._elements.$outerDialog.css({
         'left':uiw._values.dialogLeft + 'px',
         'top':uiw._values.dialogTop + 'px'
      });
      
      if (uiw._values.hasVScroll) {
         iframeHtml.css('overflow-y', 'auto');
      }
      else {
         iframeHtml.css('overflow-y', 'hidden');
      }
      
      if (uiw._values.hasHScroll) {
         iframeHtml.css('overflow-x', 'auto');
      }
      else {
         iframeHtml.css('overflow-x', 'hidden');
      }
   },
   _updateModalMeasurements: function() {
      var uiw = this;
      
      var baseDialogHeight;
      var baseDialogWidth;
      
      var maxHeight = uiw._elements.$window.height() * .9;
      var maxWidth = uiw._elements.$window.width() * .9;
      
      var iframeHeight;
      var iframeWidth;
      
      var accountForScrollbar = 25;
      
      var dialogWidth;
      var dialogLeft;
      
      var widthTooBig;
      
      baseDialogHeight = 
         uiw._elements.$outerDialog.outerHeight(true) +
         uiw._elements.$dialog.outerHeight(true) - 
         2*uiw._elements.$dialog.height()
      ;
      
      baseDialogWidth = 
         uiw._elements.$outerDialog.outerWidth(true) -
         uiw._elements.$outerDialog.width() +
         uiw._elements.$dialog.outerWidth(true) - 
         uiw._elements.$dialog.width()
      ;
      
      uiw._elements.$iframe.css({
         'height':'1px',
         'width':'1px'
      });
      
      if (uiw._values.heightWidthMode === 'AUTO') {
         iframeHeight = uiw._elements.$iframe.contents().height();
         iframeWidth = uiw._elements.$iframe.contents().width();      
      } else if (uiw._values.heightWidthMode === 'STATIC_PX') {
         iframeHeight = Number(uiw._values.height);
         iframeWidth = Number(uiw._values.width);
      } else if (uiw._values.heightWidthMode === 'STATIC_%') {
         iframeHeight = uiw._elements.$window.height() * (uiw._values.height/100);
         iframeWidth = uiw._elements.$window.width() * (uiw._values.width/100); 
      }
      
      uiw._elements.$iframe.css({
         'height':'100%',
         'width':'100%'
      });
      
      if (baseDialogHeight + iframeHeight > maxHeight) {
         uiw._values.hasVScroll = true
         iframeHeight = maxHeight - baseDialogHeight;
         baseDialogWidth = baseDialogWidth;
      }
      else {
         uiw._values.hasVScroll = false;
      }
      
      if (uiw._values.hasVScroll) {
         widthTooBig =
            (baseDialogWidth + iframeWidth + accountForScrollbar> maxWidth);
      }
      else {
         widthTooBig = (baseDialogWidth + iframeWidth > maxWidth);
      }
      
      if (widthTooBig) {
         uiw._values.hasHScroll = true;
         iframeWidth = maxWidth - baseDialogWidth;
         
         if (!uiw._values.hasVScroll) {
            if (baseDialogHeight + iframeHeight + accountForScrollbar > maxHeight) {
               uiw._values.hasVScroll = true;
               iframeHeight = maxHeight - baseDialogHeight;
            }
            else {
               iframeHeight = iframeHeight + accountForScrollbar;
            }
         }
      }
      else {
         uiw._values.hasHScroll = false;
         if (uiw._values.hasVScroll) {
            iframeWidth = iframeWidth + accountForScrollbar;
         }
      }
      
      dialogWidth = baseDialogWidth + iframeWidth;
      dialogLeft = (uiw._elements.$window.width()/2) - (dialogWidth/2);
      
      if (dialogLeft < 0) {
         dialogLeft = 0;
      }
      
      uiw._values.dialogTop = uiw._elements.$window.height()*.05 + $(document).scrollTop();
      uiw._values.iframeHeight = iframeHeight;
      uiw._values.iframeWidth = iframeWidth;
      uiw._values.dialogLeft = dialogLeft;
   },
   close: function(modalPageCloseValue) {           
      uiw._values.modalPageCloseValue = modalPageCloseValue;   
      uiw._elements.$dialog.dialog('close');
   }
});
})(apex.jQuery);